Pārlūkot izejas kodu

Merge pull request #98 from BepInEx/feature-cake-build

Add CakeBuild support
Geoffrey Horsington 5 gadi atpakaļ
vecāks
revīzija
a74708c653
8 mainītis faili ar 624 papildinājumiem un 149 dzēšanām
  1. 2 3
      .gitignore
  2. 52 0
      BUILDING.md
  3. 1 0
      build.bat
  4. 187 0
      build.cake
  5. 258 0
      build.ps1
  6. 117 0
      build.sh
  7. BIN
      lib/UnityEngine.dll
  8. 7 146
      scripts/jenkins_master.groovy

+ 2 - 3
.gitignore

@@ -287,6 +287,5 @@ __pycache__/
 *.odx.cs
 *.xsd.cs
 
-# Unity libraries
-lib/UnityEngine.dll
-lib/UnityEngine.CoreModule.dll
+# Cake binaries
+tools/

+ 52 - 0
BUILDING.md

@@ -0,0 +1,52 @@
+# Building BepInEx
+
+You can build BepInEx two ways: by using MSBuild-compatible IDE or the CakeBuild script.
+
+## CakeBuild script
+
+You can use the included [cakebuild](https://cakebuild.net/) script that allows you to automatically get dependencies, build and package everything.
+
+**Make sure you have either [MSBuild (via Visual Studio Installer)](https://visualstudio.microsoft.com/downloads/) or [Mono](https://www.mono-project.com/) installed.**
+
+### Windows (Command Line)
+
+Clone or [download](https://github.com/BepInEx/BepInEx/archive/master.zip) this repository.  
+After that, run
+
+```bat
+build.bat -target=Build
+```
+
+### Windows (PowerShell)
+
+Clone or [download](https://github.com/BepInEx/BepInEx/archive/master.zip) this repository.  
+After that, run
+
+```ps
+./build.ps1 -target=Build
+```
+
+Make sure you have the execution policy set to enable running scripts.
+
+### Linux (Bash)
+
+Clone or [download](https://github.com/BepInEx/BepInEx/archive/master.zip) this repository.  
+After that, run
+
+```sh
+./build.sh --target=Build
+```
+
+### Additional build targets
+
+The build script provides the following build targets (that you can pass via the `target` parameter)
+
+| Target        | Description                                                              |
+| ------------- | ------------------------------------------------------------------------ |
+| `Build`       | Pulls dependencies and builds BepInEx                                    |
+| `MakeDist`    | Runs `Build` and creates distributable packages into `bin/dist` folder   |
+| `Pack`        | Runs `MakeDist` and zips everything into archives into `bin/dist` folder |
+
+## MSBuild
+
+Download and IDE (for example Visual Studio), open the solution file and build it.

+ 1 - 0
build.bat

@@ -0,0 +1 @@
+powershell.exe -ExecutionPolicy Bypass -NoProfile -NonInteractive -File %CD%\build.ps1 %*

+ 187 - 0
build.cake

@@ -0,0 +1,187 @@
+#addin nuget:?package=Cake.FileHelpers&version=3.2.1
+#addin nuget:?package=SharpZipLib&version=1.2.0
+#addin nuget:?package=Cake.Compression&version=0.2.4
+#addin nuget:?package=Cake.Json&version=4.0.0
+#addin nuget:?package=Newtonsoft.Json&version=11.0.2
+
+var target = Argument("target", "Build");
+var isBleedingEdge = Argument("bleeding_edge", false);
+var buildId = Argument("build_id", 0);
+var lastBuildCommit = Argument("last_build_commit", "");
+
+var buildVersion = "";
+var currentCommit = RunGit("rev-parse HEAD");
+var currentCommitShort = RunGit("log -n 1 --pretty=\"format:%h\"").Trim();
+var currentBranch = RunGit("rev-parse --abbrev-ref HEAD");
+var latestTag = RunGit("describe --tags --abbrev=0");
+
+string RunGit(string command, string separator = "") 
+{
+    using(var process = StartAndReturnProcess("git", new ProcessSettings { Arguments = command, RedirectStandardOutput = true })) 
+    {
+        process.WaitForExit();
+        return string.Join(separator, process.GetStandardOutput());
+    }
+}
+
+Task("Cleanup")
+    .Does(() =>
+{
+    Information("Removing old binaries");
+    CreateDirectory("./bin");
+    CleanDirectory("./bin");
+
+    Information("Cleaning up old build objects");
+    CleanDirectories(GetDirectories("./**/bin/"));
+    CleanDirectories(GetDirectories("./**/obj/"));
+});
+
+Task("PullDependencies")
+    .Does(() =>
+{
+    Information("Updating git submodules");
+    StartProcess("git", "submodule update --init --recursive");
+
+    Information("Restoring NuGet packages");
+    NuGetRestore("./BepInEx.sln");
+});
+
+Task("Build")
+    .IsDependentOn("Cleanup")
+    .IsDependentOn("PullDependencies")
+    .Does(() =>
+{
+    var bepinExProperties = Directory("./BepInEx/Properties");
+
+    if(isBleedingEdge)
+    {
+        CopyFile(bepinExProperties + File("AssemblyInfo.cs"), bepinExProperties + File("AssemblyInfo.cs.bak"));
+        ReplaceRegexInFiles(bepinExProperties + File("AssemblyInfo.cs"), "([0-9]+\\.[0-9]+\\.[0-9]+\\.)[0-9]+", "${1}" + buildId);
+
+        FileAppendText(bepinExProperties + File("AssemblyInfo.cs"), 
+            TransformText("\n[assembly: BuildInfo(\"BLEEDING EDGE Build #<%buildNumber%> from <%shortCommit%> at <%branchName%>\")]\n")
+                .WithToken("buildNumber", buildId)
+                .WithToken("shortCommit", currentCommit)
+                .WithToken("branchName", currentBranch)
+                .ToString());
+    }
+
+    buildVersion = FindRegexMatchInFile(bepinExProperties + File("AssemblyInfo.cs"), "[0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+", System.Text.RegularExpressions.RegexOptions.None);
+
+    var buildSettings = new MSBuildSettings {
+        Configuration = "Release",
+        Restore = true
+    };
+    buildSettings.Properties["TargetFrameworks"] = new []{ "net35" };
+    MSBuild("./BepInEx.sln", buildSettings);
+})
+.Finally(() => 
+{
+    var bepinExProperties = Directory("./BepInEx/Properties");
+    if(isBleedingEdge)
+    {
+        DeleteFile(bepinExProperties + File("AssemblyInfo.cs"));
+        MoveFile(bepinExProperties + File("AssemblyInfo.cs.bak"), bepinExProperties + File("AssemblyInfo.cs"));
+    }
+});
+
+const string DOORSTOP_VER = "2.11.1.0";
+const string DOORSTOP_DLL = "winhttp.dll";
+Task("DownloadDoorstop")
+    .Does(() =>
+{
+    Information("Downloading Doorstop");
+
+    var doorstopPath = Directory("./bin/doorstop");
+    var doorstopX64Path = doorstopPath + File("doorstop_x64.zip");
+    var doorstopX86Path = doorstopPath + File("doorstop_x86.zip");
+    CreateDirectory(doorstopPath);
+
+    DownloadFile($"https://github.com/NeighTools/UnityDoorstop/releases/download/v{DOORSTOP_VER}/Doorstop_x64_{DOORSTOP_VER}.zip", doorstopX64Path);
+    DownloadFile($"https://github.com/NeighTools/UnityDoorstop/releases/download/v{DOORSTOP_VER}/Doorstop_x86_{DOORSTOP_VER}.zip", doorstopX86Path);
+
+    Information("Extracting Doorstop");
+    ZipUncompress(doorstopX86Path, doorstopPath + Directory("x86"));
+    ZipUncompress(doorstopX64Path, doorstopPath + Directory("x64"));
+});
+
+Task("MakeDist")
+    .IsDependentOn("Build")
+    .IsDependentOn("DownloadDoorstop")
+    .Does(() =>
+{
+    var distDir = Directory("./bin/dist");
+    var distPatcherDir = distDir + Directory("patcher");
+    var doorstopPath = Directory("./bin/doorstop");
+
+    CreateDirectory(distDir);
+    CreateDirectory(distPatcherDir);
+
+    var changelog = TransformText("<%commit_count%> commits since <%last_tag%>\r\n\r\nChangelog (excluding merges):\r\n<%commit_log%>")
+                        .WithToken("commit_count", RunGit($"rev-list --count {latestTag}..HEAD"))
+                        .WithToken("last_tag", latestTag)
+                        .WithToken("commit_log", RunGit($"--no-pager log --no-merges --pretty=\"format:* (%h) [%an] %s\" {latestTag}..HEAD", "\r\n"))
+                        .ToString();
+
+    void PackageBepin(string arch) 
+    {
+        var distArchDir = distDir + Directory(arch);
+        var doorstopArchPath = doorstopPath + Directory(arch) + File(DOORSTOP_DLL);
+        var bepinDir = distArchDir + Directory("BepInEx");
+        
+        CreateDirectory(distArchDir);
+        CreateDirectory(bepinDir + Directory("core"));
+        CreateDirectory(bepinDir + Directory("plugins"));
+        CreateDirectory(bepinDir + Directory("patchers"));
+
+        CopyFiles("./bin/*.*", bepinDir + Directory("core"));
+        CopyFileToDirectory(doorstopArchPath, distArchDir);
+        FileWriteText(distArchDir + File("changelog.txt"), changelog);
+    }
+
+    PackageBepin("x86");
+    PackageBepin("x64");
+    CopyFileToDirectory(File("./bin/patcher/BepInEx.Patcher.exe"), distPatcherDir);
+});
+
+Task("Pack")
+    .IsDependentOn("MakeDist")
+    .Does(() =>
+{
+    var distDir = Directory("./bin/dist");
+    var commitPrefix = isBleedingEdge ? $"_{currentCommitShort}_" : "_";
+
+    Information("Packing BepInEx");
+    ZipCompress(distDir + Directory("x86"), distDir + File($"BepInEx_x86{commitPrefix}{buildVersion}.zip"));
+    ZipCompress(distDir + Directory("x64"), distDir + File($"BepInEx_x64{commitPrefix}{buildVersion}.zip"));
+
+    Information("Packing BepInEx.Patcher");
+    ZipCompress(distDir + Directory("patcher"), distDir + File($"BepInEx_Patcher{commitPrefix}{buildVersion}.zip"));
+
+    if(isBleedingEdge) 
+    {
+        FileWriteText(distDir + File("info.json"), 
+            SerializeJsonPretty(new Dictionary<string, object>{
+                ["id"] = buildId.ToString(),
+                ["date"] = DateTime.Now.ToString("o"),
+                ["changelog"] = "",
+                ["artifacts"] = new Dictionary<string, object>[] {
+                    new Dictionary<string, object> {
+                        ["file"] = $"BepInEx_x64{commitPrefix}{buildVersion}.zip",
+                        ["description"] = "BepInEx for x64 machines"
+                    },
+                    new Dictionary<string, object> {
+                        ["file"] = $"BepInEx_x86{commitPrefix}{buildVersion}.zip",
+                        ["description"] = "BepInEx for x86 machines"
+                    },
+                    new Dictionary<string, object> {
+                        ["file"] = $"BepInEx_Patcher{commitPrefix}{buildVersion}.zip",
+                        ["description"] = "Hardpatcher for BepInEx. IMPORTANT: USE ONLY IF DOORSTOP DOES NOT WORK FOR SOME REASON!"
+                    }
+                },
+                ["commit"] = currentCommit
+            }));
+    }
+});
+
+RunTarget(target);

+ 258 - 0
build.ps1

@@ -0,0 +1,258 @@
+##########################################################################
+# This is the Cake bootstrapper script for PowerShell.
+# This file was downloaded from https://github.com/cake-build/resources
+# Feel free to change this file to fit your needs.
+##########################################################################
+
+<#
+
+.SYNOPSIS
+This is a Powershell script to bootstrap a Cake build.
+
+.DESCRIPTION
+This Powershell script will download NuGet if missing, restore NuGet tools (including Cake)
+and execute your Cake build script with the parameters you provide.
+
+.PARAMETER Script
+The build script to execute.
+.PARAMETER Target
+The build script target to run.
+.PARAMETER Configuration
+The build configuration to use.
+.PARAMETER Verbosity
+Specifies the amount of information to be displayed.
+.PARAMETER ShowDescription
+Shows description about tasks.
+.PARAMETER DryRun
+Performs a dry run.
+.PARAMETER SkipToolPackageRestore
+Skips restoring of packages.
+.PARAMETER ScriptArgs
+Remaining arguments are added here.
+
+.LINK
+https://cakebuild.net
+
+#>
+
+[CmdletBinding()]
+Param(
+    [string]$Script = "build.cake",
+    [string]$Target,
+    [string]$Configuration,
+    [ValidateSet("Quiet", "Minimal", "Normal", "Verbose", "Diagnostic")]
+    [string]$Verbosity,
+    [switch]$ShowDescription,
+    [Alias("WhatIf", "Noop")]
+    [switch]$DryRun,
+    [switch]$SkipToolPackageRestore,
+    [Parameter(Position=0,Mandatory=$false,ValueFromRemainingArguments=$true)]
+    [string[]]$ScriptArgs
+)
+
+# Attempt to set highest encryption available for SecurityProtocol.
+# PowerShell will not set this by default (until maybe .NET 4.6.x). This
+# will typically produce a message for PowerShell v2 (just an info
+# message though)
+try {
+    # Set TLS 1.2 (3072), then TLS 1.1 (768), then TLS 1.0 (192), finally SSL 3.0 (48)
+    # Use integers because the enumeration values for TLS 1.2 and TLS 1.1 won't
+    # exist in .NET 4.0, even though they are addressable if .NET 4.5+ is
+    # installed (.NET 4.5 is an in-place upgrade).
+    # PowerShell Core already has support for TLS 1.2 so we can skip this if running in that.
+    if (-not $IsCoreCLR) {
+        [System.Net.ServicePointManager]::SecurityProtocol = 3072 -bor 768 -bor 192 -bor 48
+    }
+  } catch {
+    Write-Output 'Unable to set PowerShell to use TLS 1.2 and TLS 1.1 due to old .NET Framework installed. If you see underlying connection closed or trust errors, you may need to upgrade to .NET Framework 4.5+ and PowerShell v3'
+  }
+
+[Reflection.Assembly]::LoadWithPartialName("System.Security") | Out-Null
+function MD5HashFile([string] $filePath)
+{
+    if ([string]::IsNullOrEmpty($filePath) -or !(Test-Path $filePath -PathType Leaf))
+    {
+        return $null
+    }
+
+    [System.IO.Stream] $file = $null;
+    [System.Security.Cryptography.MD5] $md5 = $null;
+    try
+    {
+        $md5 = [System.Security.Cryptography.MD5]::Create()
+        $file = [System.IO.File]::OpenRead($filePath)
+        return [System.BitConverter]::ToString($md5.ComputeHash($file))
+    }
+    finally
+    {
+        if ($file -ne $null)
+        {
+            $file.Dispose()
+        }
+    }
+}
+
+function GetProxyEnabledWebClient
+{
+    $wc = New-Object System.Net.WebClient
+    $proxy = [System.Net.WebRequest]::GetSystemWebProxy()
+    $proxy.Credentials = [System.Net.CredentialCache]::DefaultCredentials
+    $wc.Proxy = $proxy
+    return $wc
+}
+
+Write-Host "Preparing to run build script..."
+
+if(!$PSScriptRoot){
+    $PSScriptRoot = Split-Path $MyInvocation.MyCommand.Path -Parent
+}
+
+$TOOLS_DIR = Join-Path $PSScriptRoot "tools"
+$ADDINS_DIR = Join-Path $TOOLS_DIR "Addins"
+$MODULES_DIR = Join-Path $TOOLS_DIR "Modules"
+$NUGET_EXE = Join-Path $TOOLS_DIR "nuget.exe"
+$CAKE_EXE = Join-Path $TOOLS_DIR "Cake/Cake.exe"
+$NUGET_URL = "https://dist.nuget.org/win-x86-commandline/latest/nuget.exe"
+$PACKAGES_CONFIG = Join-Path $TOOLS_DIR "packages.config"
+$PACKAGES_CONFIG_MD5 = Join-Path $TOOLS_DIR "packages.config.md5sum"
+$ADDINS_PACKAGES_CONFIG = Join-Path $ADDINS_DIR "packages.config"
+$MODULES_PACKAGES_CONFIG = Join-Path $MODULES_DIR "packages.config"
+
+# Make sure tools folder exists
+if ((Test-Path $PSScriptRoot) -and !(Test-Path $TOOLS_DIR)) {
+    Write-Verbose -Message "Creating tools directory..."
+    New-Item -Path $TOOLS_DIR -Type Directory | Out-Null
+}
+
+# Make sure that packages.config exist.
+if (!(Test-Path $PACKAGES_CONFIG)) {
+    Write-Verbose -Message "Downloading packages.config..."
+    try {
+        $wc = GetProxyEnabledWebClient
+        $wc.DownloadFile("https://cakebuild.net/download/bootstrapper/packages", $PACKAGES_CONFIG)
+    } catch {
+        Throw "Could not download packages.config."
+    }
+}
+
+# Try find NuGet.exe in path if not exists
+if (!(Test-Path $NUGET_EXE)) {
+    Write-Verbose -Message "Trying to find nuget.exe in PATH..."
+    $existingPaths = $Env:Path -Split ';' | Where-Object { (![string]::IsNullOrEmpty($_)) -and (Test-Path $_ -PathType Container) }
+    $NUGET_EXE_IN_PATH = Get-ChildItem -Path $existingPaths -Filter "nuget.exe" | Select -First 1
+    if ($NUGET_EXE_IN_PATH -ne $null -and (Test-Path $NUGET_EXE_IN_PATH.FullName)) {
+        Write-Verbose -Message "Found in PATH at $($NUGET_EXE_IN_PATH.FullName)."
+        $NUGET_EXE = $NUGET_EXE_IN_PATH.FullName
+    }
+}
+
+# Try download NuGet.exe if not exists
+if (!(Test-Path $NUGET_EXE)) {
+    Write-Verbose -Message "Downloading NuGet.exe..."
+    try {
+        $wc = GetProxyEnabledWebClient
+        $wc.DownloadFile($NUGET_URL, $NUGET_EXE)
+    } catch {
+        Throw "Could not download NuGet.exe."
+    }
+}
+
+# Save nuget.exe path to environment to be available to child processed
+$env:NUGET_EXE = $NUGET_EXE
+$env:NUGET_EXE_INVOCATION = if ($IsLinux -or $IsMacOS) {
+    "mono `"$NUGET_EXE`""
+} else {
+    "`"$NUGET_EXE`""
+}
+
+# Restore tools from NuGet?
+if(-Not $SkipToolPackageRestore.IsPresent) {
+    Push-Location
+    Set-Location $TOOLS_DIR
+
+    # Check for changes in packages.config and remove installed tools if true.
+    [string] $md5Hash = MD5HashFile $PACKAGES_CONFIG
+    if((!(Test-Path $PACKAGES_CONFIG_MD5)) -Or
+    ($md5Hash -ne (Get-Content $PACKAGES_CONFIG_MD5 ))) {
+        Write-Verbose -Message "Missing or changed package.config hash..."
+        Get-ChildItem -Exclude packages.config,nuget.exe,Cake.Bakery |
+        Remove-Item -Recurse -Force
+    }
+
+    Write-Verbose -Message "Restoring tools from NuGet..."
+    
+    $NuGetOutput = Invoke-Expression "& $env:NUGET_EXE_INVOCATION install -ExcludeVersion -OutputDirectory `"$TOOLS_DIR`""
+
+    if ($LASTEXITCODE -ne 0) {
+        Throw "An error occurred while restoring NuGet tools."
+    }
+    else
+    {
+        $md5Hash | Out-File $PACKAGES_CONFIG_MD5 -Encoding "ASCII"
+    }
+    Write-Verbose -Message ($NuGetOutput | Out-String)
+
+    Pop-Location
+}
+
+# Restore addins from NuGet
+if (Test-Path $ADDINS_PACKAGES_CONFIG) {
+    Push-Location
+    Set-Location $ADDINS_DIR
+
+    Write-Verbose -Message "Restoring addins from NuGet..."
+    $NuGetOutput = Invoke-Expression "& $env:NUGET_EXE_INVOCATION install -ExcludeVersion -OutputDirectory `"$ADDINS_DIR`""
+
+    if ($LASTEXITCODE -ne 0) {
+        Throw "An error occurred while restoring NuGet addins."
+    }
+
+    Write-Verbose -Message ($NuGetOutput | Out-String)
+
+    Pop-Location
+}
+
+# Restore modules from NuGet
+if (Test-Path $MODULES_PACKAGES_CONFIG) {
+    Push-Location
+    Set-Location $MODULES_DIR
+
+    Write-Verbose -Message "Restoring modules from NuGet..."
+    $NuGetOutput = Invoke-Expression "& $env:NUGET_EXE_INVOCATION install -ExcludeVersion -OutputDirectory `"$MODULES_DIR`""
+
+    if ($LASTEXITCODE -ne 0) {
+        Throw "An error occurred while restoring NuGet modules."
+    }
+
+    Write-Verbose -Message ($NuGetOutput | Out-String)
+
+    Pop-Location
+}
+
+# Make sure that Cake has been installed.
+if (!(Test-Path $CAKE_EXE)) {
+    Throw "Could not find Cake.exe at $CAKE_EXE"
+}
+
+$CAKE_EXE_INVOCATION = if ($IsLinux -or $IsMacOS) {
+    "mono `"$CAKE_EXE`""
+} else {
+    "`"$CAKE_EXE`""
+}
+
+# Build Cake arguments
+$cakeArguments = ""
+If ($Script) {
+    $cakeArguments += @("`"$Script`"");
+}
+if ($Target) { $cakeArguments += "-target=`"$Target`"" }
+if ($Configuration) { $cakeArguments += "-configuration=$Configuration" }
+if ($Verbosity) { $cakeArguments += "-verbosity=$Verbosity" }
+if ($ShowDescription) { $cakeArguments += "-showdescription" }
+if ($DryRun) { $cakeArguments += "-dryrun" }
+$cakeArguments += $ScriptArgs
+
+# Start Cake
+Write-Host "Running build script..."
+Invoke-Expression "& $CAKE_EXE_INVOCATION $($cakeArguments -join " ")"
+exit $LASTEXITCODE

+ 117 - 0
build.sh

@@ -0,0 +1,117 @@
+#!/usr/bin/env bash
+
+##########################################################################
+# This is the Cake bootstrapper script for Linux and OS X.
+# This file was downloaded from https://github.com/cake-build/resources
+# Feel free to change this file to fit your needs.
+##########################################################################
+
+# Define directories.
+SCRIPT_DIR=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )
+TOOLS_DIR=$SCRIPT_DIR/tools
+ADDINS_DIR=$TOOLS_DIR/Addins
+MODULES_DIR=$TOOLS_DIR/Modules
+NUGET_EXE=$TOOLS_DIR/nuget.exe
+CAKE_EXE=$TOOLS_DIR/Cake/Cake.exe
+PACKAGES_CONFIG=$TOOLS_DIR/packages.config
+PACKAGES_CONFIG_MD5=$TOOLS_DIR/packages.config.md5sum
+ADDINS_PACKAGES_CONFIG=$ADDINS_DIR/packages.config
+MODULES_PACKAGES_CONFIG=$MODULES_DIR/packages.config
+
+# Define md5sum or md5 depending on Linux/OSX
+MD5_EXE=
+if [[ "$(uname -s)" == "Darwin" ]]; then
+    MD5_EXE="md5 -r"
+else
+    MD5_EXE="md5sum"
+fi
+
+# Define default arguments.
+SCRIPT="build.cake"
+CAKE_ARGUMENTS=()
+
+# Parse arguments.
+for i in "$@"; do
+    case $1 in
+        -s|--script) SCRIPT="$2"; shift ;;
+        --) shift; CAKE_ARGUMENTS+=("$@"); break ;;
+        *) CAKE_ARGUMENTS+=("$1") ;;
+    esac
+    shift
+done
+
+# Make sure the tools folder exist.
+if [ ! -d "$TOOLS_DIR" ]; then
+  mkdir "$TOOLS_DIR"
+fi
+
+# Make sure that packages.config exist.
+if [ ! -f "$TOOLS_DIR/packages.config" ]; then
+    echo "Downloading packages.config..."
+    curl -Lsfo "$TOOLS_DIR/packages.config" https://cakebuild.net/download/bootstrapper/packages
+    if [ $? -ne 0 ]; then
+        echo "An error occurred while downloading packages.config."
+        exit 1
+    fi
+fi
+
+# Download NuGet if it does not exist.
+if [ ! -f "$NUGET_EXE" ]; then
+    echo "Downloading NuGet..."
+    curl -Lsfo "$NUGET_EXE" https://dist.nuget.org/win-x86-commandline/latest/nuget.exe
+    if [ $? -ne 0 ]; then
+        echo "An error occurred while downloading nuget.exe."
+        exit 1
+    fi
+fi
+
+# Restore tools from NuGet.
+pushd "$TOOLS_DIR" >/dev/null
+if [ ! -f "$PACKAGES_CONFIG_MD5" ] || [ "$( cat "$PACKAGES_CONFIG_MD5" | sed 's/\r$//' )" != "$( $MD5_EXE "$PACKAGES_CONFIG" | awk '{ print $1 }' )" ]; then
+    find . -type d ! -name . ! -name 'Cake.Bakery' | xargs rm -rf
+fi
+
+mono "$NUGET_EXE" install -ExcludeVersion
+if [ $? -ne 0 ]; then
+    echo "Could not restore NuGet tools."
+    exit 1
+fi
+
+$MD5_EXE "$PACKAGES_CONFIG" | awk '{ print $1 }' >| "$PACKAGES_CONFIG_MD5"
+
+popd >/dev/null
+
+# Restore addins from NuGet.
+if [ -f "$ADDINS_PACKAGES_CONFIG" ]; then
+    pushd "$ADDINS_DIR" >/dev/null
+
+    mono "$NUGET_EXE" install -ExcludeVersion
+    if [ $? -ne 0 ]; then
+        echo "Could not restore NuGet addins."
+        exit 1
+    fi
+
+    popd >/dev/null
+fi
+
+# Restore modules from NuGet.
+if [ -f "$MODULES_PACKAGES_CONFIG" ]; then
+    pushd "$MODULES_DIR" >/dev/null
+
+    mono "$NUGET_EXE" install -ExcludeVersion
+    if [ $? -ne 0 ]; then
+        echo "Could not restore NuGet modules."
+        exit 1
+    fi
+
+    popd >/dev/null
+fi
+
+# Make sure that Cake has been installed.
+if [ ! -f "$CAKE_EXE" ]; then
+    echo "Could not find Cake.exe at '$CAKE_EXE'."
+    exit 1
+fi
+
+# Start Cake
+exec mono "$CAKE_EXE" $SCRIPT "${CAKE_ARGUMENTS[@]}"

BIN
lib/UnityEngine.dll


+ 7 - 146
scripts/jenkins_master.groovy

@@ -11,7 +11,7 @@ pipeline {
         stage('Pull Projects') {
             steps {
                 script {
-                    if(fileExists('./last_build_commit'))
+                    if(fileExists('last_build_commit'))
                         lastBuildCommit = readFile 'last_build_commit'
                     else 
                         lastBuildCommit = ""
@@ -21,141 +21,26 @@ pipeline {
 
                 dir('BepInEx') {
                     git 'https://github.com/BepInEx/BepInEx.git'
-                    
+
                     script {
-                        shortCommit = sh(returnStdout: true, script: "git log -n 1 --pretty=format:'%h'").trim()
                         longCommit = sh(returnStdout: true, script: "git rev-parse HEAD").trim()
-                        branchName = sh(returnStdout: true, script: "git rev-parse --abbrev-ref HEAD").trim()
-                        latestTag = sh(returnStdout: true, script: "git describe --tags `git rev-list --tags --max-count=1`").trim()
-
-                        if(!params.IS_BE) {
-                            latestTagOnCurrentBranch = sh(returnStdout: true, script: "git describe --abbrev=0 --tags").trim()
-                            sh("git checkout ${latestTagOnCurrentBranch}")
-                        }
-
-                        if(params.IS_BE)
-                            changelog = gitChangelog from: [type: 'REF', value: "${latestTag}"], returnType: 'STRING', template: """BepInEx Bleeding Edge Changelog
-Changes since ${latestTag}:
-
-{{#commits}}
-{{^merge}}
-* [{{hash}}] ({{authorName}}) {{messageTitle}}
-{{/merge}}
-{{/commits}}""", to: [type: 'COMMIT', value: "${longCommit}"]
-
-                        if(lastBuildCommit != "") {
-                            htmlChangelog = gitChangelog from: [type: 'COMMIT', value: lastBuildCommit], returnType: 'STRING',
-                            template: """<ul>{{#commits}}{{^merge}}<li>[<code>{{hash}}</code>] ({{authorName}}) {{messageTitle}}</li>{{/merge}}{{/commits}}</ul>""", to: [type: 'COMMIT', value: "${longCommit}"] }
-                        else
-                            htmlChangelog = ""
-                    }
-
-                    sh 'git submodule update --init --recursive'
-                }
-
-                dir('Unity') {
-                     withCredentials([string(credentialsId: 'bepis_dll_git_url', variable: 'bepis_dll_git_url')]) {
-                        git credentialsId: 'b1f2f78b-f0c5-4a81-8b4a-55b6b8bdbbe3', url: "${bepis_dll_git_url}/JenkinsStuff/UnityDLL.git"
-                     }
-                }
-
-                dir('Doorstop') {
-                    sh '''  tag="v2.11.1.0";
-                    version="2.11.1.0";
-                    wget https://github.com/NeighTools/UnityDoorstop/releases/download/$tag/Doorstop_x64_$version.zip;
-                    wget https://github.com/NeighTools/UnityDoorstop/releases/download/$tag/Doorstop_x86_$version.zip;
-                    unzip -o Doorstop_x86_$version.zip winhttp.dll -d x86;
-                    unzip -o Doorstop_x64_$version.zip winhttp.dll -d x64;'''
-                }
-            }
-        }
-        stage('Prepare BepInEx') {
-            steps {
-                dir('BepInEx') {
-                    sh "mkdir -p lib"
-
-                    // Ghetto fix to force TargetFrameworks to only net35
-                    sh "find . -type f -name \"*.csproj\" -exec sed -i -E \"s/(<TargetFrameworks>)[^<]+(<\\/TargetFrameworks>)/\\1net35\\2/g\" {} +"
-                    sh "nuget restore"
-                }
-
-                dir('BepInEx/BepInEx') {
-                    // Write additional BuildInfo into the Bleeding Edge BepInEx.dll
-                    dir('Properties') {
-                        script {
-                            if(params.IS_BE) {
-                                sh "sed -i -E \"s/([0-9]+\\.[0-9]+\\.[0-9]+\\.)[0-9]+/\\1${env.BUILD_NUMBER}/\" AssemblyInfo.cs"
-                                sh "echo '[assembly: BuildInfo(\"BLEEDING EDGE Build #${env.BUILD_NUMBER} from ${shortCommit} at ${branchName}\")]' >> AssemblyInfo.cs"
-                            }
-                            versionNumber = sh(returnStdout: true, script: "grep -m 1 -oE \"[0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+\" AssemblyInfo.cs").trim()
-                        }
                     }
                 }
             }
         }
         stage('Build BepInEx') {
             steps {
-                sh 'cp -f Unity/5.6/UnityEngine.dll BepInEx/lib/UnityEngine.dll'
                 dir('BepInEx') {
-                    sh 'msbuild /p:Configuration=Release /t:Build /p:DebugType=none BepInEx.sln'
-                }
-
-                dir('Build/bin') {
-                    sh 'cp -fr ../../BepInEx/bin/* .'
-                }
-                dir('BepInEx/bin') {
-                    deleteDir()
+                    sh "chmod u+x build.sh"
+                    sh "./build.sh --target=Pack --bleeding_edge=${params.IS_BE} --build_id=${currentBuild.id} --last_build_commit=${lastBuildCommit}"
                 }
             }
         }
         stage('Package') {
             steps {
-                dir('Build/dist') {
-                    sh 'mkdir -p BepInEx/core BepInEx/patchers BepInEx/plugins'
-                    sh 'cp -fr -t BepInEx/core ../bin/*'
-                    sh 'rm -f BepInEx/core/UnityEngine.dll'
-                    sh 'rm -rf BepInEx/core/patcher'
-
-                    sh 'cp -f ../../BepInEx/doorstop/doorstop_config.ini doorstop_config.ini'
-                    sh 'cp -f ../../Doorstop/x86/winhttp.dll winhttp.dll'
-                    
-                    script {
-                        if(params.IS_BE) {
-                            writeFile encoding: 'UTF-8', file: 'changelog.txt', text: changelog
-                            sh 'unix2dos changelog.txt'
-                            commitPrefix = "_${shortCommit}_"
-                        } 
-                        else
-                            commitPrefix = "_"
-                    }
-
-                    sh "zip -r9 BepInEx_x86${commitPrefix}${versionNumber}.zip ./*"
-                    
-                    sh 'cp -f ../../Doorstop/x64/winhttp.dll winhttp.dll'
-                    
-                    sh 'unix2dos doorstop_config.ini'
-                    
-                    sh "zip -r9 BepInEx_x64${commitPrefix}${versionNumber}.zip ./* -x \\*.zip"
-
+                dir('BepInEx/bin/dist') {
                     archiveArtifacts "*.zip"
                 }
-                dir('Build/patcher') {
-                    sh 'cp -fr ../bin/patcher/* .'
-                    script {
-                        if(params.IS_BE) {
-                            writeFile encoding: 'UTF-8', file: 'changelog.txt', text: changelog
-                            sh 'unix2dos changelog.txt'
-                        }
-                    }
-                    sh "zip -r9 BepInEx_Patcher${commitPrefix}${versionNumber}.zip ./*"
-
-                    archiveArtifacts "*.zip"
-                }
-
-                dir('Artifacts') {
-                    sh 'mv ../Build/patcher/*.zip .'
-                    sh 'mv ../Build/dist/*.zip .'
-                }
             }
         }
     }
@@ -169,32 +54,8 @@ Changes since ${latestTag}:
             script {
                 lastBuildCommit = longCommit
                 if(params.IS_BE) {
-                    dir('Artifacts') {
-                        def data = [
-                            id: env.BUILD_NUMBER,
-                            date: sh(returnStdout: true, script: 'date -Iseconds -u'),
-                            changelog: htmlChangelog,
-                            artifacts: [
-                                [
-                                    file: "BepInEx_x64${commitPrefix}${versionNumber}.zip",
-                                    description: "BepInEx for x64 machines"
-                                ],
-                                [
-                                    file: "BepInEx_x86${commitPrefix}${versionNumber}.zip",
-                                    description: "BepInEx for x86 machines"
-                                ],
-                                [
-                                    file: "BepInEx_Patcher${commitPrefix}${versionNumber}.zip",
-                                    description: "Hardpatcher for BepInEx. IMPORTANT: USE ONLY IF DOORSTOP DOES NOT WORK FOR SOME REASON!"
-                                ]
-                            ]
-                        ]
-
-                        def json = groovy.json.JsonOutput.toJson(data)
-                        json = groovy.json.JsonOutput.prettyPrint(json)
-                        writeFile file: 'info.json', text: json
-
-                        def filesToSend = findFiles(glob: '*').collect {it.name}
+                    dir('BepInEx/bin/dist') {
+                        def filesToSend = findFiles(glob: '*.*').collect {it.name}
                         withCredentials([string(credentialsId: 'bepisbuilds_addr', variable: 'BEPISBUILDS_ADDR')]) {
                             sh """curl --upload-file "{${filesToSend.join(',')}}" --ftp-pasv --ftp-skip-pasv-ip --ftp-create-dirs --ftp-method singlecwd --disable-epsv ftp://${BEPISBUILDS_ADDR}/bepinex_be/artifacts/${env.BUILD_NUMBER}/"""
                         }